#include "stdafx.h"
#include "Log.h"
#include "Utility.h"

using namespace std;

std::ofstream Log::m_ofs;

void Log::Start(const std::string& file_name)
{
	SetCurrentDirectory(Utility::GetProgramFolder().c_str());
	m_ofs.open(file_name.c_str());
}

void Log::Stop()
{
	m_ofs.close();
}

void Log::Add(const std::string& text)
{
	string format_text = text;
	size_t index;
	while ((index = format_text.find("\r\n")) != string::npos){
		format_text.replace(index, 2, " ");
	}
	while ((index = format_text.find("\n")) != string::npos){
		format_text.replace(index, 1, " ");
	}
	m_ofs << COleDateTime::GetCurrentTime().Format() << " - " << format_text << endl;
}

void Log::LastError(DWORD e)
{
	LPVOID lpMsgBuf = 0;
	if (!FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, e, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL)){
		LPVOID lpMsgBuf2 = 0;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, GetLastError(), MAKELANGID(LANG_NEUTRAL, SUBLANG_SYS_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL);
#ifdef _DEBUG
//		AfxMessageBox((char*)lpMsgBuf2);
#endif
	}
	Add((LPCTSTR)lpMsgBuf);
	LocalFree(lpMsgBuf);
}
